// Copyright 2007 Regents of the University of California

// SETI_BOINC is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.

// SETI_BOINC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.

// You should have received a copy of the GNU General Public License along
// with SETI_BOINC; see the file COPYING.  If not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// In addition, as a special exception, the Regents of the University of
// California give permission to link the code of this program with libraries
// that provide specific optimized fast Fourier transform (FFT) functions and
// distribute a linked executable.  You must obey the GNU General Public
// License in all respects for all of the code used other than the FFT library
// itself.  Any modification required to support these libraries must be
// distributed in source code form.  If you modify this file, you may extend
// this exception to your version of the file, but you are not obligated to
// do so. If you do not wish to do so, delete this exception statement from
// your version.

//uje: Replacing ap_gfx_main.cpp with this one to get around shared memory problems. *x only!
#if _GNU_SOURCE || __MINGW32__ || __APPLE__ || __FreeBSD__
#include <errno.h>
#include "astropulse.h"
#include "ap_shmem.h"
#include "boinc_api.h"

AP_GDATA* ap_gdata;

void update_shmem() {
}

void ap_shmem_init(APP_INIT_DATA& app_init_data) {
   // Checking for blank statefile
   //fprintf(stderr, "In ap_shmem.cpp: in ap_shmem_init(): Starting non graphical application.\n");
   AP_SHMEM* &ap_shmem=Astropulse::client.ap_shmem;

    // initialize ap_shmem with placement new.
    ap_shmem = new AP_SHMEM(); //uje: The cast of new (ap_shmem) AP_SHMEM() caused SIGSEGVs with gcc
    //uje: Needs refinement with gcc
	// Fortunately AP_SHMEM doesn't contain any self-referential pointers.
    AP_SHMEM *tmp=new AP_SHMEM();
	memcpy(ap_shmem,tmp,sizeof(AP_SHMEM));
	delete tmp;

    ap_gdata = &(ap_shmem->ap_gdata);
    boinc_register_timer_callback(update_shmem);
}
#endif //_GNU_SOURCE  || __MINGW32__ || __APPLE__ || __FreeBSD__
