/* Win32:
px - C-optimized for all IA-32 processors 
a6 - Optimized for Pentium III processors 
w7 - Optimized for Pentium 4 processors 
t7 - Optimized for Pentium 4 processors with Streaming SIMD Extensions 3 (SSE3)
v8 - New Optimizations for 32-bit applications on Intel Core 2 and Intel Xeon 5100 Processors
p8 - New Optimizations for 32-bit applications on 45nm Intel Core2 Duo (Penryn) family processors
*/
#undef IPP_W32DLL
#if defined(__SSE41__)
	#define PREFIX(x)	y8_##x //available prefixes are mx,m7,u8,y8
#elif defined(__SSSE3__)
	#ifdef _WIN64
		#define PREFIX(x)	u8_##x //available prefixes are mx,m7,u8,y8
	#else
		#define PREFIX(x)	v8_##x
	#endif
#elif defined(__SSE3__)
	#ifdef _WIN64
		#define PREFIX(x)	m7_##x //available prefixes are mx,m7,u8,y8
	#else
		#define PREFIX(x)	t7_##x
	#endif
#elif defined(__SSE2__)
	#ifdef _WIN64
//		#define M7 1
		#pragma message ("-----x64 sse2-----")
		#define PREFIX(x)	m7_##x //available prefixes are mx,m7,u8,y8
	#else
		#define PREFIX(x)	w7_##x
	#endif
#else 
	#ifdef _WIN64
		#define PREFIX(x)	mx_##x //mx too slow to be good choice...
	#else 
		#define PREFIX(x)	px_##x
	#endif
#endif

#define ippsFFTFree_C_32fc PREFIX(ippsFFTFree_C_32fc)
#define ippsFFTInitAlloc_C_32fc PREFIX(ippsFFTInitAlloc_C_32fc)
#define ippsFFTInv_CToC_32fc PREFIX(ippsFFTInv_CToC_32fc)
#define	ippsFFTFwd_CToC_32fc PREFIX(ippsFFTFwd_CToC_32fc)
#define	ippsFFTFwd_CToC_32fc_I PREFIX(ippsFFTFwd_CToC_32fc_I)
#define ippsFFTInv_CToC_32fc_I PREFIX(ippsFFTInv_CToC_32fc_I)
#define ippsFFTGetBufSize_C_32fc PREFIX(ippsFFTGetBufSize_C_32fc)
#define ippsConv_32f PREFIX(ippsConv_32f)
#define ippsMalloc_8u PREFIX(ippsMalloc_8u)
#define ippsMalloc_32fc PREFIX(ippsMalloc_32fc)
#define ippsFree PREFIX(ippsFree)
#define ippmTranspose_m_32f PREFIX(ippmTranspose_m_32f)
#include <ipp.h>
