#!/usr/bin/perl

# Purpose: arrange pulses by scale, and list all peak powers for each scale.

$filename = $ARGV[0];
if ($filename eq "") { $filename = "pulse.out"; }
open(INFILE, $filename);

$step = 0;

while($line = <INFILE>) {
  if($line =~ /<peak_power>(.*)\<\/peak_power>/) {
    $peak_power = $1;
    $step++;
  }
  if($line =~ /<scale>(.*)<\/scale>/) {
    $scale = $1;
    $step++;
  }
  if($step == 2) {
    push @{ $collated[$scale] }, ($peak_power); 
    $step = 0;
  }    
}

for ($i = 0; $i < $#collated; $i++) {
  print "Scale $i: \n";
  print "@{ $collated[$i] }\n\n";
}
