#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>

#include "sqlapi.h"
#include "db_table.h"
#include "xml_util.h"
#include "sched_config.h"
#include "ap_schema.h"
#include "app_config.h"
#include "sqlhdr.h"

const char * from_db = "ap_db@sci_master_tcp";

int main(int argc, char ** argv) {

 ap_signal apsig,from_thisrow;
 frag31_signal aasig,to_thisrow;
 int retval, get_next_retval;
 int i, match, dontmatch;
 std::vector<int> id_list;
 
 char type[32];
 int modulo, remainder, maxnum, minid, maxid;
       
 if (argc != 6) {
     fprintf(stderr, "Usage: ap_signal_test modulo remainder maximum_number_of_elements minimum_id maximum_id\n");
     exit (1);
 } else {
     modulo = atoi(argv[1]);
     remainder = atoi(argv[2]);
     maxnum = atoi(argv[3]);
     minid = atoi(argv[4]);
     maxid = atoi(argv[5]);
 }

// how to call read_and_compare_dbs?

 char c_string[256]; 
 std::string where_clause;

   if (modulo != 1 && remainder != 0) { 
     sprintf(c_string, "where id >= %d and id <= %d and MOD(id, %d) = %d",  minid, maxid,  modulo, remainder);
   } else {
     sprintf(c_string, "where id >= %d and id <= %d",  minid, maxid);
   }
   where_clause = c_string;
   std::cerr << "where clause: " << where_clause << "\n";

   retval = db_change(from_db);
   fprintf(stderr, "db_change(%s) returns %d\n", from_db, retval);
   retval = apsig.open_query(where_clause);
   fprintf(stderr, "open_query returns %d, %d\n", retval, sql_last_error_code());
   i = 0;
   while (get_next_retval = apsig.get_next() && (i++) < maxnum) id_list.push_back (apsig.id);
   apsig.close_query();

   std::vector<int>::iterator id_iter = id_list.begin();

   match = dontmatch = 0;
   while (id_iter != id_list.end()) {
     sprintf(c_string, "where id = %d", (*id_iter));
     where_clause = c_string;
     apsig.open_query(where_clause);
     apsig.get_next();
     from_thisrow = apsig;
     apsig.close_query();
     aasig.open_query(where_clause);
     aasig.get_next();
     to_thisrow = aasig;
     aasig.close_query();
     std::cerr << "FROM DATABASE:\n" << from_thisrow.print_xml(0,1,0) << "\n\nTO DATABASE:\n" << to_thisrow.print_xml(0,1,0) << "\n";
     if (from_thisrow.print(0,1,0) == to_thisrow.print(0,1,0)) { match++; }
     else { 
       dontmatch++;
       fprintf(stderr,"DON'T MATCH!!!\n");
     }  
     fprintf(stderr,"--------------------------\n");
     id_iter++;
   } 
   fprintf(stderr,"num match: %d don't match: %d\n",match,dontmatch);
   exit (0);

}
